local AHighIntensityLaserProjectile = import('/lua/aeonprojectiles.lua').AHighIntensityLaserProjectile

ch_wpn_poison01 = Class(AHighIntensityLaserProjectile) {
    OnImpact = function(self, TargetType, TargetEntity)
	
		local unit = self:GetLauncher()
		
		if TargetEntity then
			local poisonLength = 5
			local poisonTime = 1
			
			local PoisonThread = ForkThread(function(self)
				--Bone 0 is the root bone of the mesh.
				--Bone -1 is a magic index referring to the center of the unit's collision box.
				--Bone -2 is a magic index referring to the unit's local origin.
				-- TargetEntity:GetBoneName(0) also works.
				--CreateEmitterOnEntity(TargetEntity,TargetEntity:GetArmy(),'/effects/emitters/destruction_explosion_concussion_ring_01_emit.bp')
				#__resistance_test02_emit Green Red Smoke Kinda
				#__resistance_test_emit Blue Smoke
				#_quantum_hit_flash_04_emit White Rings
				#_test_20_gaseous_emit Neon Green Fire
				#_test_commander_gate_explosion_01_emit yellow ring
				#_test_commander_gate_explosion_02_emit heavy yellow flash
				#light_green_01_emit Green Tracks
				#light_green_rotator_01_emit Stationary Green Rotator
				#molecular_resonance_cannon_01_emit Blue/White Puff
				#quark_bomb_explosion_03_emit Blue/White Splash
				
				local emitter = CreateAttachedEmitter(TargetEntity, 0, TargetEntity:GetArmy(), '/effects/emitters/build_green_paint_spray_emit.bp'):ScaleEmitter(0.5)
				WaitSeconds(1)
				
				while (poisonTime <= poisonLength) and TargetEntity:IsDead() == false do
					TargetEntity.DoTakeDamage(TargetEntity, unit, 3, 0, 'Normal')
					poisonTime = poisonTime + 1
					local emitter2 = CreateAttachedEmitter(TargetEntity, -1, TargetEntity:GetArmy(), '/effects/emitters/__resistance_test_emit.bp'):ScaleEmitter(0.4)
					WaitSeconds(0.2)
					emitter2.Destroy(emitter2)
					WaitSeconds(0.8)
				end
				emitter.Destroy(emitter)
				KillThread(self)
			end)
		end
		self:Destroy()
    end,
}

TypeClass = ch_wpn_poison01